
#include <Python.h>

int main() {
	Py_Initialize();

	// Import our test module, and find the ExceptionTest class:

	PyObject *testModule = PyImport_ImportModule( "ExceptionTest" );

	if( !testModule ) {
		printf( "Could not load the ExceptionTest module\n" );
		exit( 1 );
	}

	PyObject *cls = PyObject_GetAttrString( testModule, "ExceptionTest" );

	if( !testModule ) {
		printf( "Could not load the ExceptionTest class\n" );
		exit( 1 );
	}

	// Create an instance of the class and locate our test method:

	PyObject *clsInstance = PyObject_CallObject( cls, NULL );
	PyObject *method = PyObject_GetAttrString( clsInstance, "RaiseException" );

	PyObject *args = PyTuple_New( 0 );


	// Trigger the exception, noting the reference counts before and after 
	// when we use PyErr_Clear:

	printf( "*** Will call PyErr_Clear after exception: ***\n" );
	printf( "clsInstance refcnt before exception = %d\n", clsInstance -> ob_refcnt );

	PyObject_Call( method, args, NULL );

	if( PyErr_Occurred() )
		PyErr_Clear();

	printf( "clsInstance refcnt after exception = %d\n", clsInstance -> ob_refcnt );




	// Trigger the exception, noting the reference counts before and after 
	// when we use PyErr_Print:

	printf( "*** Will call PyErr_Print after exception: ***\n" );
	printf( "clsInstance refcnt before exception = %d\n", clsInstance -> ob_refcnt );

	PyObject_Call( method, args, NULL );

	if( PyErr_Occurred() )
		PyErr_Print();

	printf( "clsInstance refcnt after exception = %d\n", clsInstance -> ob_refcnt );




}



 	  	 
